local lfrng = CreateFrame("Frame")
local indices = {}
local armor_type = {
	["DEATHKNIGHT"] = "Plate",
	["PALADIN"] = "Plate",
	["WARRIOR"] = "Plate",
	["HUNTER"] = "Mail",
	["SHAMAN"] = "Mail",
	["DEMONHUNTER"] = "Leather",
	["DRUID"] = "Leather",
	["MONK"] = "Leather",
	["ROGUE"] = "Leather",
	["MAGE"] = "Cloth",
	["PRIEST"] = "Cloth",
	["WARLOCK"] = "Cloth",
}
local _, player_armor = UnitClass("player")
player_armor = armor_type[player_armor]

lfrng:SetScript('OnEvent', function(self, event, ...) self[event](self, ...) end)
LFGListFrame.ApplicationViewer.ScrollBox:RegisterCallback("OnScroll", function() lfrng:ListChanged() end)
-- GroupFinderFrame:HookScript("OnShow", function() lfrng:ListChanged(); end)

lfrng:RegisterEvent("LFG_LIST_APPLICANT_UPDATED")
lfrng:RegisterEvent("LFG_LIST_APPLICANT_LIST_UPDATED")
lfrng:RegisterEvent("LFG_LIST_SEARCH_RESULT_UPDATED")
lfrng:RegisterEvent("ADDON_LOADED")

StaticPopupDialogs["LFRNG_INVITE"] = {
	text = "%s",
	button1 = "Invite",
	button2 = "Cancel",
	OnAccept = function()
		C_LFGList.InviteApplicant(theOne)
	end,
	timeout = 0,
	whileDead = true,
	hideOnEscape = true,
	preferredIndex = 3,
}

function lfrng:LFG_LIST_APPLICANT_UPDATED()
	lfrng:ListChanged()
end
function lfrng:LFG_LIST_APPLICANT_LIST_UPDATED()
	lfrng:ListChanged()
end
function lfrng:LFG_LIST_SEARCH_RESULT_UPDATED()
	lfrng:ListChanged()
end

function lfrng:ADDON_LOADED()
	button = CreateFrame("Button", "lfrngRand", LFGListFrame.ApplicationViewer, "UIPanelButtonTemplate")
	button:SetPoint("RIGHT", LFGListFrame.ApplicationViewer, "TOP", 135, -135)
	-- button:SetPoint("CENTER", LFGListFrame.ApplicationViewer, "TOP",0,0)
	button:SetWidth(100)
	button:SetHeight(22)
	button:SetText("RNG")
	button.tooltip_text = "Hold shift to bypass pop-up window"
	button:SetScript("OnEnter", function(self) GameTooltip:SetOwner (self, "ANCHOR_BOTTOMRIGHT");
    GameTooltip:SetText (self.tooltip_text, nil, nil, nil, nil, true);
	GameTooltip:SetWidth (300);
    GameTooltip:Show(); end)
	button:SetScript("OnLeave", function(self) GameTooltip_Hide() end)
	
	button:HookScript("OnMouseUp", function(self, button) lfrng:InviteRandom() end)
	
	lfrngFilterArmorCheckbox = CreateFrame("CheckButton", "lfrngFilterArmorCheckbox", LFGListFrame.ApplicationViewer, "ChatConfigCheckButtonTemplate")
	lfrngFilterArmorCheckbox:HookScript("OnClick", function(self, button) lfrng:FilterArmorClick() end)
	lfrngFilterArmorCheckbox:SetPoint("BOTTOMLEFT", LFGListFrame.ApplicationViewer.InfoBackground, "BOTTOMLEFT", 115, 8)
	lfrngFilterArmorCheckboxText:SetText(" Only " .. player_armor)
	lfrngFilterArmorCheckboxText:SetFontObject("GameFontHighlightSmall")
	
	LFGListFrame.ApplicationViewer.AutoAcceptButton:SetHitRectInsets(0,-80,0,0)
	
	lfrng:UnregisterEvent("ADDON_LOADED")
end

function dump(o)
   if type(o) == 'table' then
      local s = '{ '
      for k,v in pairs(o) do
         if type(k) ~= 'number' then k = '"'..k..'"' end
         s = s .. '['..k..'] = ' .. dump(v) .. ','
      end
      return s .. '} '
   else
      return tostring(o)
   end
end

function lfrng:ListChanged()
	if LFGListFrame.ApplicationViewer.applicants == nil then return end

	local lfrng_visible = { LFGListFrame.ApplicationViewer.ScrollBox:GetFrames() }

	currentCount = 1
	while (LFGListFrame.ApplicationViewer.applicants[currentCount]) do
		theIndex = LFGListFrame.ApplicationViewer.applicants[currentCount]
		the_name, the_class = C_LFGList.GetApplicantMemberInfo(theIndex, 1)

		indices[theIndex..":list_index"] = currentCount
		indices[theIndex..":name"] = the_name
		indices[theIndex..":armor"] = armor_type[the_class]
		currentCount = currentCount + 1
	end

	for _, lfrng_entry in ipairs(lfrng_visible[1]) do
		theIndex = lfrng_entry.applicantID

		if theIndex ~= nil then 
			theName = lfrng_entry.Member1.Name:GetText()
			_, the_class = C_LFGList.GetApplicantMemberInfo(theIndex, 1)
			theArmor = indices[theIndex..":armor"]				

			local thePrefix, trash = strsplit("-",theName, 2)
			myIndex = indices[theIndex..":list_index"]

			if tonumber(thePrefix) ~= myIndex then
				if not indices[theIndex..":name"] then 
					indices[theIndex..":name"] = theName
					indices[theIndex..":armor"] = armor_type[the_class]					
				end
				lfrng_entry.Member1.Name:SetText(myIndex .. " - " .. theName)
			end
			if lfrngFilterArmorCheckbox:GetChecked() == true then 
				if (theArmor ~= player_armor and myIndex ~= nil) then
					lfrng_entry.InviteButton:Hide()
					lfrng_entry.Status:Hide()
				else
					if lfrng_entry.Status:IsVisible() == false then lfrng_entry.InviteButton:Show() end
				end
			else
				if lfrng_entry.Status:IsVisible() == false then lfrng_entry.InviteButton:Show() end
			end
		end
	end
end
function lfrng:InviteRandom()
	_, totalApplicants = C_LFGList:GetNumApplicants()
	if (LFGListFrame.ApplicationViewer.applicants == nil or totalApplicants == 0) then return end

	if lfrngFilterArmorCheckbox:GetChecked() == true then
		local filteredApplicants = { }
		local applicantIndex = 0
		
		for z = 1, totalApplicants do
			test_applicant = LFGListFrame.ApplicationViewer.applicants[z]
			if test_applicant == nil then return end
			_, the_class = C_LFGList.GetApplicantMemberInfo(test_applicant, 1)
			test_applicant_armor = armor_type[the_class]
			
			if test_applicant_armor == player_armor then
				_, applicant_state = C_LFGList.GetApplicantInfo(test_applicant)
				if applicant_state == "applied" then
					applicantIndex = applicantIndex + 1
					filteredApplicants[applicantIndex] = test_applicant
				end
			end
		end
		if applicantIndex == 0 then print("No valid applicants"); return end
		theOne = math.random(applicantIndex)
		theOne = filteredApplicants[theOne]
	else
		theIndex = math.random(totalApplicants)
		theOne = LFGListFrame.ApplicationViewer.applicants[theIndex]
	end
	the_name = C_LFGList.GetApplicantMemberInfo(theOne,1)
	if IsShiftKeyDown() then
		C_LFGList.InviteApplicant(theOne)
	else
		StaticPopup_Show ("LFRNG_INVITE",the_name)
	end
end

function lfrng:FilterArmorClick()
	if lfrngFilterArmorCheckbox:GetChecked() == true then
		lfrngRand:SetText("RNG(".. player_armor ..")")
	else
		lfrngRand:SetText("RNG")
	end
	lfrng:ListChanged()
end